% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Services.R, R/Leonardo.R, R/Terra.R,
%   R/Dockstore.R, R/Gen3.R
\docType{data}
\name{Services}
\alias{Services}
\alias{.DollarNames.Service}
\alias{operations,Service-method}
\alias{schemas,Service-method}
\alias{show,Service-method}
\alias{Service-class}
\alias{empty_object}
\alias{operations}
\alias{schemas}
\alias{tags}
\alias{$,Service-method}
\alias{Leonardo}
\alias{Leonardo-class}
\alias{operations,Leonardo-method}
\alias{Terra}
\alias{Terra-class}
\alias{operations,Terra-method}
\alias{schemas,Terra-method}
\alias{Dockstore}
\alias{Dockstore-class}
\alias{operations,Dockstore-method}
\alias{Gen3Fence}
\alias{Gen3Indexd}
\alias{Gen3Sheepdog}
\alias{Gen3Peregrine}
\title{RESTful services useful for AnVIL developers}
\usage{
empty_object

operations(x, ...)

schemas(x)

tags(x, .tags)

\S4method{$}{Service}(x, name)

Leonardo()

Terra()

Dockstore()

Gen3Fence()

Gen3Indexd()

Gen3Sheepdog()

Gen3Peregrine()
}
\arguments{
\item{x}{A `Service` instance, usually a singleton provided by the
package and documented on this page, e.g., `leonardo` or
`terra`.}

\item{...}{additional arguments passed to methods or, for
`operations,Service-method`, to the internal `get_operation()`
function.}

\item{.tags}{optional character() of tags to use to filter operations.}

\item{name}{A symbol representing a defined operation, e.g.,
`leonardo$listClusters()`.}
}
\value{
`empty_object` returns a representation to be used as
    arguments in function calls expecting the empty json object
    `\{\}`.

`Leonardo()` creates the API of the Leonard container
    deployment service at https://leonardo.dev.anvilproject.org/.

`Terra()` creates the API of the Terra cloud computational
    environemnt at https://api.firecloud.org/.

`Dockstore()` represents the API of the Dockstore platform to
    share Docker-based tools in CWL or WDL or Nextflow at
    https://dockstore.org

`gen3_*` APIs are not fully implemented, because a service
    endpoint has not been identifiied.

    `Gen3Fence()` returns the authentication API at
    https://raw.githubusercontent.com/uc-cdis/fence/master/openapis/swagger.yaml

`Gen3Indexd()` returns the indexing service API documented at
    https://raw.githubusercontent.com/uc-cdis/indexd/master/openapis/swagger.yaml

`Gen3Sheepdog` returns the submission services API at
    https://raw.githubusercontent.com/uc-cdis/sheepdog/master/openapi/swagger.yml

`Gen3Peregrine` returns the graphQL query services API at
    https://raw.githubusercontent.com/uc-cdis/peregrine/master/openapis/swagger.yaml
}
\description{
RESTful services useful for AnVIL developers
}
\examples{
empty_object

if (gcloud_exists()) {
    terra <- Terra()
    tags(terra)
    tags(terra, "Billing")
}

}
\keyword{datasets}
